<?php 

/**
 * @file ReadXml.class.php
 * @desc Use to read xml from firefox extension.
 * 
 * @author Matthieu DELOISON
 * @date 08-05-2007
 * @update
 *
 *
 * @version 0.1 
 */
 

/**
 * @note : 
 *		- 
 *
 */

 
 /**
 * @details : 
 * 		- 
 *
 *
 * @usage :
 *		- $a_xmlTxt = array("xml/content/fr/accueil.xml", "xml/content/fr/news.xml");
		  $o_reference = new ReadXml($a_xmlTxt);
		  $o_reference->createFileHTML("include/page_content/contentXML.htm");
 *
 */
class ReadXml 
{
	/* caractrisitiques des chemins */
	//private $a_XmlFile; 				// all file axml to be read

	
	
	
	// ---------------------------------- __construct() ----------------------------------------------------------
   /**
	* @brief Constructeur de la classe.
	* @param -
	*/
	public function __construct()
	{
		
	}


	// -----------------------------------------------------------------------------------------------------------
	// -------------------------------------- Mthodes publiques  ------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------
	
	
	// ---------------------------------- createFileHTML() ----------------------------------------------------------
	/**
	* @brief Create the HTML file with the content of all xml file
	* @param (string) the path and the name of the file
	* @return (boolean) true if is good else false
	*/
	public function createFileXmlFlash($s_fileUrl)
	{
		/* init var */
		$s_urlXml = $s_fileUrl;
		
		$s_documentXML = "";
		
		
		/* test la validit du fichier xml */
		libxml_clear_errors(); // vide le buffer d'erreur libxml
		
		//$o_SimpleXMLelementFlash = @simplexml_load_string($s_fileUrl, 'SimpleXMLElement'); // cre un objet SimpleXMLElement
		$o_SimpleXMLelementFlash = @simplexml_load_file($s_urlXml);
		
		
		$o_LibXMLError = libxml_get_last_error(); // Lit la dernire erreur libxml concernant l'analyse de l'objet SimpleXMLElement
		// si il y a une erreur dans le noeud xml
		if( !empty($o_LibXMLError ) )
		{
			$s_message = $o_LibXMLError->message; // rcupre le texte d'erreur
			libxml_clear_errors(); // vide le buffer d'erreur libxml
			echo " <br />- This xml file is incorrect : <br />".$s_message;
			return false;
		}
		
		
		echo "<br /> Lecture du fichier xml <br /><br />";		
		
		/* rcupre le contenu du noeud gnral */
		foreach( $o_SimpleXMLelementFlash->title as $item )
		{		
			echo "<br />";
			echo"<br />___________________________________>>> balise title gnral	: ".$item; // contenu de la balise title gnral
			$s_bigTitle = $item;
		}
		
		/* rcupre le contenu du noeud gnral */
		foreach( $o_SimpleXMLelementFlash->folder as $item )
		{		
			echo "<br />";
			echo"<br /> titre ensemble des marques pages	: ".$item->title; // titre ensemble des marques pages
			echo "<br />";
			
			$o_oneItem = self::readBookmark( $item );
			echo "<br />_>>> suite.";
			print_r( $o_oneItem );
			
			/*foreach( $item->bookmark as $item_url )
			{
				echo "<br />";
				echo"<br />item_url->title	: ".$item_url->title;
				echo"<br />_______>>> item_url->desc	: ".$item_url->desc;
				echo"<br />item_url->bookmark	: ".$item->bookmark[0]['href'];	
				
				if( $item_url->folder!=undefined )			
				{
					echo "<br /><br /> Bookmark interne<br />";
					foreach( $item->folder as $item_url )
					{
						echo "<br />";
						echo"<br />item_url->title	: ".$item_url->title;
						echo"<br />_______>>> item_url->desc	: ".$item_url->desc;
						echo"<br />item_url->bookmark	: ".$item->folder[0]->bookmark[0]['href'];	
					}
				}
			}*/
			
			echo"<br />";
		}
		
		
		
		
		$s_documentXML .= "<h3 class=\"minititre\">".$s_title."</h3>".$s_description."<br /><br />";
		
		$a_xml 	= array("\n", "\r", "&");
		$a_html = array("<br />", "<br />", "&amp;");
		$s_documentXML = str_replace($a_xml, $a_html, $s_documentXML);

		
		
		/* write the text in an html file 
		$handle = fopen($s_FileName, "w+"); 
		$i_nb_octet = fwrite($handle, $s_documentXML ); // criture dans le fichier
		
		if( $i_nb_octet===FALSE )
		{
			echo " <br />- Error occured during the writing of xml file.";
			return false;
		}
		
		// sinon criture russi, on ferme le fichier
		fclose($handle);*/
		return true;
	}


	
 	// -------------------------------------------------------------------------------------------------
	// -------------------------------- private method  ------------------------------------------------
	// -------------------------------------------------------------------------------------------------



	/**
	* @brief Destructeur de la classe
	* Utilis pour enregistrer des messages pour le debogage, fermer les fichier ouverts en criture ou en lecture, raliser des oprations
	* de nettoyage des objets utiliss...
	*
	* @param (array)
	* @return (array)
	*/
	private function readBookmark( $a_bookmark) 
	{
		$a_item = array();
		
 		foreach( $a_bookmark->bookmark as $item_url )
		{
			echo "<br />";
			echo"<br />item_url->title	: ".$item_url->title;
			echo"<br />_______>>> item_url->desc	: ".$item_url->desc;
			echo"<br />item_url->bookmark	: ".$a_bookmark->bookmark[0]['href'];
			
			$a_item = array(
			'title'				=>	$item_url->title,
			'desc'				=>	$item_url->desc,
			'url'				=>	$a_bookmark->bookmark[0]['href']
			);
		
			// converti le tableau en objet
			$o_item = (object) $a_magasin ;	
			$a_item[] = $o_item;
			
		}
		
		
 	}
	
	
	
	
 	// -------------------------------------------------------------------------------------------------
	// ---------------------------------------- Divers  ------------------------------------------------
	// -------------------------------------------------------------------------------------------------

	
 	/**
	* @brief Destructeur de la classe
	* Utilis pour enregistrer des messages pour le debogage, fermer les fichier ouverts en criture ou en lecture, raliser des oprations
	* de nettoyage des objets utiliss...
	*
	* @param 
	* @return 
	*/
	public function __destruct() 
	{
 
 	}



	/**
	 * @brief Dtermine comment la classe doit ragir lorsqu'elle est convertie en chane de caractres.
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  la reprsentation de l'objet sous forme de chane.
	 */	
	public function __toString() 
	{
		
		$s_classContent = "[Object ".__CLASS__."]<br />";
		// parcours toutes les proprits de la classe et les renvoie	
		foreach($this as $prop => $value) 
		{
		 	$s_classContent .= "$prop => $value <br />";
		}
		 
		return $s_classContent;
   	}

}
 
 
 

?>